from rocolib.api.components.Component import Component
from rocolib.api.Function import Function

c = Component()

c.addParameter("servo", "fs90r", paramType="dimension")
c.addParameter("flip", False, valueType="bool")
c.addParameter("center", True, valueType="bool")
c.addParameter("shift", 0, paramType="length")
# XXX TODO: Define type: tuple of two numbers
c.addParameter("offset", optional=True, overrides=("flip", "center", "shift"))

c.addSubcomponent("beam", "SimpleRectBeam", inherit=("length", "addTabs"), prefix=None)
c.addSubcomponent("mount", "Cutout")

c.addConstraint(("mount", "dx"), "servo", 'getDim(x, "motorwidth") * 0.99')
c.addConstraint(("mount", "dy"), "servo", 'getDim(x, "motorlength")')

c.addConstraint(("beam", "width"), "servo", 'getDim(x, "motorwidth")')
c.addConstraint(("beam", "depth"), "servo", 'getDim(x, "motorheight")')

c.inheritAllInterfaces("beam", prefix=None)
c.inheritAllInterfaces("mount")
c.addConnection(("beam", "face0"),
                ("mount", "decoration"),
                mode="hole", offset=Function(params="offset"))

c.toLibrary("ServoMount")
