from rocolib.api.components.Component import Component
from rocolib.api.Function import Function

c = Component()

c.addSubcomponent("boatwithservo", "BoatWithServoMount", inherit=True, prefix=None)
c.inheritAllInterfaces("boatwithservo")
c.addSubcomponent("espStack", "StackMount", inherit=True)
c.inheritAllInterfaces("espStack")
c.addSubcomponent("batterystackmount", "BatteryStackMount")
c.inheritAllInterfaces("batterystackmount")

c.addSubcomponent("topPortSplit", "SplitEdge")
c.addConstraint(("topPortSplit", "toplength"), ("topDistance"), "(x,)")
c.addConstraint(("topPortSplit", "botlength"), ("topDistance", "espStack.stack.length"), "(x[1], x[0] - x[1])") #but the value of the new component's boat.length parameter is completely disconnected from the value of the boat component's boat.length parameter
c.addConnection(("topPortSplit", "topedge0"), ("boatwithservo", "topPort")) #both face the same direction
c.addConnection(("topPortSplit", "botedge0"), ("espStack", "leftArmInterface"), angle=45)

c.addSubcomponent("topStarSplit", "SplitEdge")
c.addConstraint(("topStarSplit", "toplength"), ("topDistance"), "(x,)")
c.addConstraint(("topStarSplit", "botlength"), ("topDistance", "espStack.stack.length"), "(x[0]-x[1], x[1])") #but the value of the new component's boat.length parameter is completely disconnected from the value of the boat component's boat.length parameter
c.addConnection(("topStarSplit", "topedge0"), ("boatwithservo", "topStar")) #both face the same direction
c.addConnection(("topStarSplit", "botedge1"), ("espStack", "rightArmInterface"), tabWidth=10)

c.toLibrary("BoatWithServoMountAndStack")
