from rocolib.api.components.Component import Component
from rocolib.api.Function import Function

c = Component()

c.addSubcomponent("boat", "BoatBaseFlat", inherit=True)

# c.addParameter("length", 130, paramType="length")
# c.addParameter("width", 50, paramType="length")
# c.addParameter("depth", 40, paramType="length")

c.addParameter("driveservo", "fs90r", paramType="dimension")

for i in range(2):
    c.addSubcomponent("mount%d" %i, "SideServoMount", prefix=None)
    c.addConstraint(("mount%d" %i, "servo"), "driveservo")
    # c.addConstraint(("mount%d" %i, "length"), "boat.width")
    # c.addConstConstraint(("mount%d" %i, "center"), False)

#mirrored
c.addSubcomponent("split0", "SplitEdge")
c.addConstraint(("split0", "toplength"), "boat.length", "(x,)") #'((x[0] - getDim(x[1], "width")))'
c.addConstraint(("split0", "botlength"), ("boat.length", "driveservo"), '(x[0] - 74 - 15 - getDim(x[1], "motorlength"), 15, getDim(x[1], "motorlength"), 74)')

c.addSubcomponent("split1", "SplitEdge")
c.addConstraint(("split1", "toplength"), "boat.length", "(x,)") #'((x[0] - getDim(x[1], "width")))'
c.addConstraint(("split1", "botlength"), ("boat.length", "driveservo"), '(74, getDim(x[1], "motorlength"), 15, x[0] - 74 - 15 - getDim(x[1], "motorlength"))') #'(74, getDim(x[1], "motorlength"), x[0] - 74 - getDim(x[1], "motorlength"))'

c.addConnection(("boat", "staredge"), ("split0", "topedge0")) #topedge so that the motor mounts are placed outside of the boat hull
c.addConnection(("boat", "portedge"), ("split1", "topedge0"))
#
c.addConnection(("mount0", "botedge3"), ("split0", "botedge2"), angle=-180)
c.addConnection(("mount1", "topedge3"), ("split1", "botedge1"), angle=-180)

#Seats -- might only have space for one band that functions as a boat support
c.addSubcomponent("flopSupport", "Rectangle")
c.addConstraint(("flopSupport", "l"), "boat.width")
c.addConstraint(("flopSupport", "w"), "boat.width", "15") #asks for another param, so I just put boat.width
c.addConnection(("split0", "botedge1"), ("flopSupport", "r"), angle=90)
c.addConnection(("split1", "botedge2"), ("flopSupport", "l"), tabWidth=6, angle=90)

c.addSubcomponent("stack", "SubESP32Stack")
# for i in range(4):
#     c.addSubcomponent("support%d" %i, "Rectangle")
#     c.addConstraint(("support%d" %i, "w"), "brains", "getDim(x, 'width')/2.")
    # c.addConstraint(("support%d" %i, "l"), "depth")

c.toLibrary("PaddleboatWithCamera")
