from rocolib.api.components.Component import Component
from rocolib.api.Function import Function

c = Component()

c.addSubcomponent("doubleServoMount", "DoubleServoMount", inherit=True, prefix=None)
c.inheritAllInterfaces("doubleServoMount")
c.addSubcomponent("espStack", "StackMount", inherit=True)
#c.inheritAllInterfaces("espStack")

c.addSubcomponent("portsplit", "SplitEdge")
c.inheritAllInterfaces("portsplit")
c.addConstConstraint(("portsplit", "toplength"), (168,)) #(("doubleServoMount", "lServoMount.depth"), ("espStack", "stack.length")), "(x[0] + x[1],)"
c.addConstConstraint(("portsplit", "botlength"), (61, 10, 24, 73)) #but the value of the new component's boat.length parameter is completely disconnected from the value of the boat component's boat.length parameter

c.addConnection(("doubleServoMount", "lServoInterface"), ("portsplit", "botedge2")) #both face the same direction
c.addConnection(("espStack", "leftArmInterface"), ("portsplit", "botedge0")) #both face the same direction

c.addSubcomponent("starsplit", "SplitEdge")
c.inheritAllInterfaces("starsplit")
c.addConstConstraint(("starsplit", "toplength"), (168,))
c.addConstConstraint(("starsplit", "botlength"), (73, 24, 10, 61)) #but the value of the new component's boat.length parameter is completely disconnected from the value of the boat component's boat.length parameter

c.addConnection(("doubleServoMount", "rServoInterface"), ("starsplit", "botedge1"))
c.addConnection(("espStack", "rightArmInterface"), ("starsplit", "botedge3"), tabWidth=10)

# c.addSubcomponent("topStarSplit", "SplitEdge")
# c.addConstraint(("topStarSplit", "toplength"), ("topDistance"), "(x,)")
# c.addConstraint(("topStarSplit", "botlength"), ("topDistance", "espStack.stack.length"), "(x[0]-x[1], x[1])") #but the value of the new component's boat.length parameter is completely disconnected from the value of the boat component's boat.length parameter
# c.addConnection(("topStarSplit", "topedge0"), ("boatwithservo", "topStar")) #both face the same direction
# c.addConnection(("topStarSplit", "botedge1"), ("espStack", "rightArmInterface"), tabWidth=10)

c.inheritInterface("lmountandservosplit", ("portsplit","topedge0"))
c.inheritInterface("rmountandservosplit", ("starsplit","topedge0"))
#c.inheritInterface("espMountTab", ("espStack", "rightArmInterface")) #need to add this onto the boat, not the splitEdge

c.toLibrary("ServoMountAndStack")
