from rocolib.api.components import Component
from rocolib.api.composables.graph.Face import Face, Rectangle, RegularNGon as Shape
from rocolib.api.composables import GraphComposable as Graph
from rocolib.api.ports.EdgePort import EdgePort
import rocolib.utils.numsym as math

class ServoStrap(Component):
    _test_params = {
        'length': 50
    }

    def define(self):
        self.addParameter("length", 50)
        self.addInterface("beltEdge", EdgePort(self, None, "length"))
        self.addInterface("boatEdge", EdgePort(self, None, "length"))
        self.addInterface("tabEdge", EdgePort(self, None, "length"))

    def assemble(self):
        L = float(self.getParameter("length"))
        l = 12 + L
        graph = Graph()
        strap = Rectangle("", l, 9)
        graph.addFace(strap, "strap")

        self.composables["graph"] = graph
        self.setInterface("beltEdge", EdgePort(self, "strap.e3", "length"))
        self.setInterface("boatEdge", EdgePort(self, "strap.e1", "length"))
        self.setInterface("tabEdge", EdgePort(self, "strap.e0", "length"))

if __name__ == "__main__":
    h = ServoStrap()
    h.test()